package com.vendor.loader.ui;

package .var.folders.cl.9twcgjfx4vsg5zl73c6wxmvm0000gn.T;

import com.vendor.loader.Messages;
import com.vendor.loader.controler.GlobleControler;
import com.vendor.loader.controler.IRunnerStateChangedListener;
import com.vendor.loader.model.PartitionItem;
import com.vendor.loader.struct.UpgradeFileInfo;
import com.vendor.loader.ui.AbstractComposite;
import com.vendor.loader.ui.ControlFactory;
import com.vendor.loader.ui.FileField;
import com.vendor.loader.ui.UpgradeInfoGroup;
import com.vendor.loader.util.FileHelper;
import com.vendor.loader.util.FileUtil;
import com.vendor.loader.util.IniFileParser;
import com.vendor.loader.util.InvalidDataFormatException;
import com.vendor.loader.util.StringUtil;
import java.awt.Toolkit;
import java.io.BufferedWriter;
import java.io.File;
import java.io.FileWriter;
import java.io.IOException;
import java.util.ArrayList;
import java.util.List;
import org.apache.commons.configuration2.PropertiesConfiguration;
import org.apache.commons.configuration2.ex.ConfigurationException;
import org.dom4j.DocumentException;
import org.eclipse.osgi.util.NLS;
import org.eclipse.swt.events.SelectionListener;
import org.eclipse.swt.layout.GridData;
import org.eclipse.swt.layout.GridLayout;
import org.eclipse.swt.widgets.Button;
import org.eclipse.swt.widgets.Composite;
import org.eclipse.swt.widgets.FileDialog;
import org.eclipse.swt.widgets.Label;
import org.eclipse.swt.widgets.Layout;
import org.eclipse.swt.widgets.Text;

public class LoaderComposite extends AbstractComposite {
  public LoaderComposite(Composite parent, int style) {
    super(parent, style);
    this.contants = new String[] { "ALL", "TS_PACKAGE", "USB_PACKAGE" };
  }
  
  private static final String[] CHIPS = new String[] { "chip 0", "chip 1", "chip 2", "chip 3" };
  
  private static final String[] INI_FILTER_NAMES = new String[] { "xml Files(*.xml)", "ini Files (*.ini)" };
  
  private static final String[] INI_FILTER_EXTS = new String[] { "*.xml", "*.ini" };
  
  private UpgradeInfoGroup upgradeInfo;
  
  private Text dataPackageText;
  
  private FileField tsFileField;
  
  private FileField usbFileField;
  
  private Button usbButton;
  
  private Button tsButton;
  
  private final String[] contants;
  
  private void createTsGroup(Composite parent, String path) {
    Composite tsGroup = createGroup(parent, Messages.LoaderComposite_49, 4);
    tsGroup.setLayout((Layout)new GridLayout(1, false));
    Composite controlSectionComposite = new Composite(tsGroup, 0);
    controlSectionComposite.setLayout((Layout)new GridLayout(2, false));
    GridData gridData = new GridData(4, 1, true, false);
    controlSectionComposite.setLayoutData(gridData);
    Label dataPackageLabel = new Label(controlSectionComposite, 0);
    dataPackageLabel.setText(Messages.ControlInformationInsertionFrequencyTitle);
    dataPackageLabel
      .setToolTipText(Messages.ControlInformationInsertionFrequencyTip);
    GridData gd = new GridData();
    gd.widthHint = 350;
    dataPackageLabel.setLayoutData(gd);
    this.dataPackageText = new Text(controlSectionComposite, 2052);
    this.dataPackageText.setText("100");
    GridData dataPackageTextGd = new GridData();
    dataPackageTextGd.widthHint = 120;
    this.dataPackageText.setLayoutData(dataPackageTextGd);
    Composite FileComposite = new Composite(tsGroup, 0);
    GridLayout layout = new GridLayout();
    layout.numColumns = 4;
    FileComposite.setLayout((Layout)layout);
    FileComposite.setLayoutData(new GridData(768));
    this.tsFileField = new FileField(FileComposite, Messages.LoaderComposite_50, 100, Messages.LoaderComposite_51, 80, 268443648, "tsFileField");
    if (path == null) {
      this.tsFileField.setDefaultFileName(GlobleControler.intance.SOCT_TS);
    } else {
      this.tsFileField.setDefaultFileName(path);
    } 
    this.tsFileField.setFileExtensions(new String[] { "*.ts", "*.*" });
    this.tsButton = ControlFactory.createPushButton(FileComposite, Messages.LoaderComposite_53);
    this.tsButton.addSelectionListener((SelectionListener)new Object(this));
    GlobleControler.intance.addRunnerStateChangedListener((IRunnerStateChangedListener)this);
  }
  
  private void createUsbGroup(Composite parent, String path) {
    String title = Messages.LoaderComposite_56;
    Composite group = createGroup(parent, title, 4);
    this.usbFileField = new FileField(group, Messages.LoaderComposite_57, 100, Messages.LoaderComposite_58, 80, 268443648, "usbFileField");
    if (path == null) {
      this.usbFileField.setDefaultFileName(GlobleControler.intance.SOCT_USB);
    } else {
      this.usbFileField.setDefaultFileName(path);
    } 
    this.usbFileField.setFileExtensions(new String[] { "*.bin", "*.*" });
    this.usbButton = ControlFactory.createPushButton(group, Messages.LoaderComposite_59);
    this.usbButton.addSelectionListener((SelectionListener)new Object(this));
  }
  
  protected Composite createGroup(Composite parent, String title, int num) {
    return (Composite)ControlFactory.createGroup(parent, title, num);
  }
  
  protected void createUpgradeInfoGroup(Composite container) {
    Composite group = createGroup(container, Messages.UpgradeInfoGroup_0, 8);
    this.upgradeInfo = new UpgradeInfoGroup(group);
  }
  
  protected void saveIni(String path) {
    if (!validateInput(this.contants[0]))
      return; 
    FileDialog dlg = new FileDialog(getShell(), 8196);
    dlg.setFilterNames(INI_FILTER_NAMES);
    dlg.setFilterExtensions(INI_FILTER_EXTS);
    dlg.setFileName(path);
    dlg.setOverwrite(true);
    String fileName = dlg.open();
    if (fileName == null || fileName.isEmpty())
      return; 
    if (fileName.toUpperCase().lastIndexOf("INI") > 0) {
      String tsfile = null;
      if (this.tsFileField != null)
        tsfile = this.tsFileField.getFilePath(); 
      String usbfile = this.usbFileField.getFilePath();
      FileWriter fileWriter = null;
      BufferedWriter bufferedWriter = null;
      try {
        fileWriter = new FileWriter(fileName);
        bufferedWriter = new BufferedWriter(fileWriter);
        PropertiesConfiguration propertie = new PropertiesConfiguration();
        if (tsfile != null) {
          propertie.getLayout().setComment("ts_file_name", "[packer_tsfilename]");
          propertie.setProperty("ts_file_name", StringUtil.addQuote(tsfile));
        } 
        propertie.setProperty("usb_file_name", StringUtil.addQuote(usbfile));
        propertie.getLayout().setBlancLinesBefore("Download_PID", 1);
        propertie.getLayout().setComment("Download_PID", "[packer_attr]");
        propertie.setProperty("Download_PID", 
            StringUtil.convertString(this.upgradeInfo.getDownloadPid(), 2));
        propertie.setProperty("Download_TableId", 
            StringUtil.convertString(this.upgradeInfo.getDownloadTableId(), 2));
        propertie.setProperty("manufacturer_ID", 
            StringUtil.convertString(this.upgradeInfo.getManufacturerId(), 4));
        propertie.setProperty("hardware_version", 
            StringUtil.convertString(this.upgradeInfo.getHardwareVersion(), 8));
        propertie.setProperty("software_version", 
            StringUtil.convertString(this.upgradeInfo.getSoftwareVersion(), 8));
        propertie.setProperty("start_sn", StringUtil.convertString(this.upgradeInfo
              .getStartSn(), 8));
        propertie.setProperty("end_sn", 
            StringUtil.convertString(this.upgradeInfo.getEndSn(), 8));
        propertie.getLayout().setComment("bin_file_num", "[packer_file]");
        propertie.getLayout().setBlancLinesBefore("bin_file_num", 1);
        propertie.setProperty("bin_file_num", String.valueOf(this.updateFiles.size()));
        for (int i = 1; i <= this.updateFiles.size(); i++) {
          UpgradeFileInfo f = this.updateFiles.get(i - 1);
          String sel = null;
          if (f.isSel()) {
            sel = "1";
          } else {
            sel = "0";
          } 
          propertie.setProperty("flash_sel" + i, sel);
          propertie.setProperty("flash_partitionname" + i, f.getPartitionName());
          propertie.setProperty("flash_partitionversion" + i, String.valueOf(f.getPartitionVersion()));
          propertie.setProperty("flash_partitionversiontag" + i, 
              String.valueOf(f.getPartitionVerifyTag()));
          propertie.setProperty("bin_name" + i, 
              StringUtil.addQuote(f.getFileName()));
          propertie.setProperty("flash_addr" + i, 
              StringUtil.toHexString(f.getStartAddress(), 8));
          propertie.setProperty("flash_type" + i, 
              String.valueOf(f.getFlashType().ordinal()));
          propertie.setProperty("flash_system" + i, f.getFileSystem().name());
          propertie.setProperty("flashindex" + i, String.valueOf(f.getFlashIndex()));
          propertie.setProperty("file_length" + i, String.valueOf(f.getLength()));
        } 
        propertie.write(bufferedWriter);
        showMessage(Messages.LoaderComposite_85);
      } catch (IOException e) {
        showError(Messages.LoaderComposite_12);
      } catch (ConfigurationException e) {
        showError(Messages.LoaderComposite_12);
      } finally {
        try {
          if (fileWriter != null)
            fileWriter.close(); 
        } catch (IOException iOException) {}
        try {
          if (bufferedWriter != null)
            bufferedWriter.close(); 
        } catch (IOException iOException) {}
      } 
    } else if (fileName.toUpperCase().lastIndexOf("XML") > 0) {
      try {
        File out = new File(fileName);
        List<PartitionItem> burn = new ArrayList<>();
        for (int i = 0; i < this.updateFiles.size(); i++) {
          UpgradeFileInfo f = this.updateFiles.get(i);
          f.validateFileName();
          PartitionItem item = new PartitionItem();
          item.setChecked(f.isSel());
          item.setFile(new File(f.getFileName()));
          item.setFileSystem(f.getFileSystem());
          item.setFlashType(f.getFlashType());
          item.setLength(f.getLength());
          item.setName(f.getPartitionName());
          item.setStart(f.getStartAddress());
          item.setPartitionVersione(f.getPartitionVersion());
          item.setPartitionVersionTag(f.getPartitionVerifyTag());
          burn.add(item);
        } 
        PartitionItem.save(out, burn);
        showMessage(Messages.LoaderComposite_85);
      } catch (Exception e) {
        showError(Messages.LoaderComposite_12);
      } 
    } 
  }
  
  protected void setUseXMLPathAsParent(boolean UseXMLPathAsParent) {
    this.useXMLPathAsParent = UseXMLPathAsParent;
  }
  
  private String loadIniFile(String fileName) {
    if (fileName == null || fileName.isEmpty())
      return fileName; 
    try {
      IniFileParser parser = new IniFileParser(fileName);
      if (this.tsFileField != null)
        this.tsFileField.setDefaultFileName(GlobleControler.intance.SOCT_TS); 
      if (this.usbFileField != null)
        this.usbFileField.setDefaultFileName(GlobleControler.intance.SOCT_USB); 
      if (this.upgradeInfo != null)
        this.upgradeInfo.setInput(parser, parser.getUpgradeInfo()); 
      this.updateFiles = parser.getUpgradFiles();
    } catch (InvalidDataFormatException e) {
      showError(e.getMessage());
    } catch (Exception e) {
      showError(Messages.LoaderComposite_86);
    } 
    return fileName;
  }
  
  protected String loadIni() {
    FileDialog dlg = new FileDialog(getShell(), 4100);
    dlg.setFilterNames(INI_FILTER_NAMES);
    dlg.setFilterExtensions(INI_FILTER_EXTS);
    String fileName = dlg.open();
    if (fileName != null) {
      File file = new File(fileName);
      if (!file.exists()) {
        showError(String.format(Messages.UpgradeInfoGroup_FileNotFound, new Object[] { fileName }));
        return "";
      } 
    } 
    if (fileName != null && !fileName.isEmpty()) {
      if (fileName.toUpperCase().endsWith("INI"))
        return loadIniFile(fileName); 
      if (fileName.toUpperCase().endsWith("XML")) {
        List<PartitionItem> load = null;
        try {
          load = PartitionItem.load(new File(fileName), this.useXMLPathAsParent);
        } catch (DocumentException e) {
          showError(Messages.XMLINVALID);
        } 
        if (load == null)
          return ""; 
        if (load.isEmpty())
          try {
            throw new DocumentException();
          } catch (DocumentException documentException) {} 
        try {
          IniFileParser parser = new IniFileParser(load);
          if (this.tsFileField != null)
            this.tsFileField
              .setDefaultFileName(GlobleControler.intance.SOCT_TS); 
          this.usbFileField
            .setDefaultFileName(GlobleControler.intance.SOCT_USB);
          this.upgradeInfo.setInput(parser, parser.getUpgradeInfo());
          this.updateFiles = parser.getUpgradFiles();
        } catch (IOException iOException) {
        
        } catch (InvalidDataFormatException invalidDataFormatException) {}
        return fileName;
      } 
      return "";
    } 
    return "";
  }
  
  private boolean valiDataPackageInput(String dataPackageStr) {
    if (dataPackageStr.isEmpty()) {
      showError(NLS.bind(Messages.FileSize_Null, Messages.ControlInformationInsertionFrequency));
      return false;
    } 
    try {
      int dataPackage = Integer.parseInt(dataPackageStr);
      if (dataPackage < 5 || dataPackage > 200) {
        showError(NLS.bind(Messages.DataPackageError, Messages.ControlInformationInsertionFrequency));
        return false;
      } 
    } catch (NumberFormatException numberFormatException) {
      showError(Messages.DataPackageError);
      return false;
    } 
    return true;
  }
  
  private boolean validateInput(String type) {
    if (this.updateFiles.size() == 0) {
      showError(Messages.LoaderComposite_87);
      return false;
    } 
    if (!FileHelper.checkUpgradeFileInfo(this.updateFiles))
      return false; 
    if (this.updateFiles.size() > 256) {
      String message = String.format(Messages.LoaderComposite_88, new Object[] { Integer.valueOf(256) });
      showError(message);
      return false;
    } 
    for (UpgradeFileInfo file : this.updateFiles) {
      try {
        FileUtil.checkAddressConflict(file, this.updateFiles);
      } catch (InvalidDataFormatException e) {
        showError(e.getMessage());
        return false;
      } 
    } 
    if (!this.upgradeInfo.hasInputText())
      return false; 
    if (!this.upgradeInfo.validateInput())
      return false; 
    if (this.tsFileField != null) {
      if (type.equals(this.contants[0]) && (
        !this.tsFileField.hasInputText(Messages.LoaderComposite_5) || 
        !this.usbFileField.hasInputText(Messages.LoaderComposite_60)))
        return false; 
      if (type.equals(this.contants[1]) && 
        !this.tsFileField.hasInputText(Messages.LoaderComposite_5))
        return false; 
    } 
    if (type.equals(this.contants[2]) && 
      !this.usbFileField.hasInputText(Messages.LoaderComposite_60))
      return false; 
    return true;
  }
  
  public void createLoaderContents(Composite comp) {
    int screenHeight = (Toolkit.getDefaultToolkit().getScreenSize()).height;
    if (screenHeight <= 768) {
      createPartFileContentControl(comp, 180);
    } else {
      createPartFileContentControl(comp, 380);
    } 
    createUpgradeInfoGroup(comp);
    String tsPath = null;
    String usbPath = null;
    ArrayList<String> pathList = FileField.loadFilterPath("tempPath.ini");
    for (String str : pathList) {
      if (str.startsWith("socttspath")) {
        tsPath = str.split("=")[1];
        continue;
      } 
      if (str.startsWith("soctusbpath"))
        usbPath = str.split("=")[1]; 
    } 
    Object object = comp.getParent().getData("SUPPORTTS");
    if (object != null && object instanceof String) {
      String value = (String)object;
      if (value.equals("YES"))
        createTsGroup(comp, tsPath); 
    } 
    createUsbGroup(comp, usbPath);
  }
  
  protected String[] getChipList() {
    return CHIPS;
  }
  
  public void start() {
    if (this.tsButton != null) {
      if (this.tsButton.isDisposed())
        return; 
      this.tsButton.setEnabled(false);
    } 
    if (this.usbButton != null) {
      if (this.usbButton.isDisposed())
        return; 
      this.usbButton.setEnabled(false);
    } 
  }
  
  public void stop() {
    if (this.tsButton != null) {
      if (this.tsButton.isDisposed())
        return; 
      this.tsButton.setEnabled(true);
    } 
    if (this.usbButton != null) {
      if (this.usbButton.isDisposed())
        return; 
      this.usbButton.setEnabled(true);
    } 
  }
}
